/// <reference types="node" />
import { Signal } from "./signals";
import { inspect } from "util";
export declare class Cancellable {
    private impl;
    cancelled: Signal<CancelledHandler>;
    constructor();
    get isCancelled(): boolean;
    throwIfCancelled(): void;
    cancel(): void;
    [inspect.custom](): string;
    combine(other: Cancellable): Cancellable;
    static withTimeout(ms: any): Cancellable;
}
export type CancelledHandler = () => void;
